; 

      .486                      ; create 32 bit code
      .model flat, stdcall      ; 32 bit memory model
      option casemap :none      ; case sensitive 

;     include files
;     ~~~~~~~~~~~~~
      include \masm32\include\windows.inc
      include \masm32\include\masm32.inc
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\dialogs.inc
      include \masm32\macros\macros.asm     ; the macro file

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib

    ; ----------------------------------------
    ; prototypes for local procedures go here
    ; ----------------------------------------
      QePlugIn       PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
      replacedlg     PROTO :DWORD,:DWORD 
      replacedlgProc PROTO :DWORD,:DWORD,:DWORD,:DWORD
      Edit1Proc      PROTO :DWORD,:DWORD,:DWORD,:DWORD
      Edit2Proc      PROTO :DWORD,:DWORD,:DWORD,:DWORD
      wordreplace    PROTO :DWORD,:DWORD,:DWORD,:DWORD

    .data?
      align 4
      hDllInstance  dd ?
      lpEdit1Proc   dd ?
      lpEdit2Proc   dd ?
      hEdit1        dd ?
      hEdit2        dd ?
      flag          dd ?
      source        dd ?
      dest          dd ?
      w1len         dd ?
      w2len         dd ?
      word1         db 128 dup (?)
      word2         db 128 dup (?)

    .code

; 

LibMain proc instance:DWORD,reason:DWORD,unused:DWORD 

    push instance
    pop hDllInstance
    mov eax, TRUE

    ret

LibMain endp

; 

QePlugIn proc hInst:DWORD,hMain:DWORD,hEd:DWORD,hTool:DWORD,hStat:DWORD

    LOCAL hMem  :DWORD
    LOCAL mLen  :DWORD
    LOCAL hBuf  :DWORD
    LOCAL Cr    :CHARRANGE
    
    mov flag, 0

    invoke SendMessage,hEd,EM_EXGETSEL,0,ADDR Cr    ; get current selection in editor

    mov eax, Cr.cpMin
    cmp Cr.cpMax, eax                               ; test the length for zero
    jne @F
    fn MessageBox, \
            hMain,"Please Select A Block Of Text First", \
                 "No Text Selected",MB_OK
    ret                                             ; exit after showing error
  @@:

    mov ecx, Cr.cpMax
    sub ecx, Cr.cpMin
    mov mLen, ecx                                   ; get the text length
    mov hMem, alloc(mLen)                           ; allocate memory for it
    invoke SendMessage,hEd,EM_GETSELTEXT,0,hMem     ; read selected text into memory

    invoke replacedlg,hInst,hMain                   ; call dialog to get words
    cmp flag, 0                                     ; exit on cancel
    je quit

 ;     mov eax, w1len
 ;     cmp w2len, eax                                  ; check if 2nd word is longer than first
 ;     ja greater                                      ; jump to larger memory strategy
 ;     shl mLen, 1                                     ; double it
 ;     mov hBuf, alloc(mLen)                           ; if same or less, allocate double size buffer
 ;     jmp next1
 ;   greater:
 ;     invoke IntDiv,w2len,w1len                       ; divide second word len by first
 ;     add eax, 1                                      ; add 1 to round upwards
 ;     invoke IntMul,mLen,eax                          ; multiply "mLen" by result
 ;     shl mLen, 1                                     ; double it
 ;     mov hBuf, alloc(mLen)                           ; allocate that amount of memory
 ;   next1:

    mov hBuf, alloc(1024*1024*4)                    ; allocate 4 meg for output

  ; ----------------------------------------------
  ; replace words in source and write it to buffer
  ; ----------------------------------------------
    invoke wordreplace,hMem,hBuf,ADDR word1,ADDR word2

  ; -------------------------------------------------------
  ; replace the original text in editor with text in buffer
  ; -------------------------------------------------------
    invoke SendMessage,hEd,EM_REPLACESEL,TRUE,hBuf

    free hBuf

  quit:
    free hMem

    ret

QePlugIn endp

; 

replacedlg proc Instance:DWORD,Parent:DWORD 

    Dialog "Replace Whole Words", \         ; caption
           "MS Sans Serif",8, \             ; font,pointsize
            WS_OVERLAPPED or \              ; styles for
            WS_SYSMENU or DS_CENTER, \      ; dialog window
            5, \                            ; number of controls
            50,50,250,85, \                ; x y co-ordinates
            1024                            ; memory buffer size

    DlgEdit    ES_MULTILINE or ES_LEFT or WS_BORDER or WS_TABSTOP,8,8,178,13,150
    DlgEdit    ES_MULTILINE or ES_LEFT or WS_BORDER or WS_TABSTOP,8,24,178,13,151
    DlgButton "OK",    WS_TABSTOP,196, 8,40,13,IDOK
    DlgButton "Cancel",WS_TABSTOP,196,24,40,13,IDCANCEL

    DlgStatic "Case Sensitive Word Replace In Selected Text",SS_LEFT,8,42,200,25,999

    CallModalDialog Instance,Parent,replacedlgProc,ADDR Instance

    ret

replacedlg endp

; 

replacedlgProc proc hWin:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 

    LOCAL tlen  :DWORD
    LOCAL bsize :DWORD

    .if uMsg == WM_INITDIALOG
      invoke SendMessage,hWin,WM_SETICON,1,
                         FUNC(LoadIcon,NULL,IDI_ASTERISK)

      mov hEdit1, FUNC(GetDlgItem,hWin,150)
      invoke SetWindowLong,hEdit1,GWL_WNDPROC,Edit1Proc
      mov lpEdit1Proc, eax

      mov hEdit2, FUNC(GetDlgItem,hWin,151)
      invoke SetWindowLong,hEdit2,GWL_WNDPROC,Edit2Proc
      mov lpEdit2Proc, eax

    ; -------------------------------------
    ; return 1 to set focus to 1st control
    ; -------------------------------------
      mov eax, 1
      ret

    .elseif uMsg == WM_COMMAND
      .if wParam == IDOK
        .if FUNC(GetWindowTextLength,hEdit1) == 0
          invoke SetFocus,hEdit1
          xor eax, eax
          ret
        .endif
        .if FUNC(GetWindowTextLength,hEdit2) == 0
          invoke SetFocus,hEdit2
          xor eax, eax
          ret
        .endif

        invoke GetWindowText,hEdit1,ADDR word1,128
        mov w1len, eax
        invoke GetWindowText,hEdit2,ADDR word2,128
        mov w2len, eax

        mov flag, 1
        jmp quit_dialog

    ; ------------------------
    ; code for OK button here
    ; ------------------------
      .elseif wParam == IDCANCEL
        jmp quit_dialog
      .endif

    .elseif uMsg == WM_CLOSE
       quit_dialog:
       invoke EndDialog,hWin,0

    .endif

    ; -------------------------------
    ; return zero for default action
    ; -------------------------------
      xor eax, eax
      ret

replacedlgProc endp

; 

Edit1Proc proc hCtl   :DWORD,
               uMsg   :DWORD,
               wParam :DWORD,
               lParam :DWORD

    .if uMsg == WM_CHAR
      .if wParam == 13
        .if FUNC(GetWindowTextLength,hCtl) == 0
          invoke SetFocus,hEdit1
        .else
          invoke SetFocus,hEdit2
        .endif
      .endif
    .endif

    invoke CallWindowProc,lpEdit1Proc,hCtl,uMsg,wParam,lParam

    ret

Edit1Proc endp

; 

Edit2Proc proc hCtl   :DWORD,
               uMsg   :DWORD,
               wParam :DWORD,
               lParam :DWORD

    .if uMsg == WM_CHAR
      .if wParam == 13
        .if FUNC(GetWindowTextLength,hEdit1) == 0
          invoke SetFocus,hEdit1
        .elseif FUNC(GetWindowTextLength,hCtl) == 0
          invoke SetFocus,hEdit2
        .endif
      .endif

    .endif

    invoke CallWindowProc,lpEdit2Proc,hCtl,uMsg,wParam,lParam

    ret

Edit2Proc endp

; 

    .data
    align 4
    chtbl \
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0     ; 31
      db 0,1,0,1,1,1,1,0,0,0,0,0,0,0,0,0     ; 47
      db 1,1,1,1,1,1,1,1,1,1,0,0,0,0,0,1     ; 63   ; numbers
      db 1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1     ; 79   ; upper case
      db 1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,1     ; 95
      db 0,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1     ; 111  ; lower case
      db 1,1,1,1,1,1,1,1,1,1,1,0,0,0,0,0     ; 127
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
      db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

    ; characters     ! # $ % & ? @ _
    ; numbers        0123456789
    ; upper case     ABCDEFGHIJKLMNOPQRSTUVWXYZ
    ; lower case     abcdefghijklmnopqrstuvwxyz

    .code

; 

comment * -----------------------------------------
        Algorithm scans the source buffer for words
        made up of  acceptable  characters. When it
        finds a word, it  tests if the word matches
        the first word and it  replaces it with the
        second in the destination buffer if it does.
        ----------------------------------------- *
align 4

wordreplace proc src:DWORD,dst:DWORD,wrd1:DWORD,wrd2:DWORD

    LOCAL buffer[512]:BYTE

    push esi
    push edi

    mov esi, src
    mov edi, dst
    xor eax, eax
    jmp badchar
  ; ---------------------------------
  ; handle unacceptable characters
  ; ---------------------------------
  align 4
  prebad:
    xor eax, eax                    ; szCmp alters EAX so clear it again
    sub esi, 1
  badchar:
    mov al, BYTE PTR [esi]
    add esi, 1
    cmp BYTE PTR [chtbl+eax], 1     ; test if BYTE is allowable character
    je pregood
    test eax, eax                   ; test if terminator
    jz repout
    mov [edi], al                   ; write BYTE to destination buffer
    add edi, 1
    jmp badchar
  ; ---------------------------------
  ; handle acceptable characters
  ; ---------------------------------
  align 4
  pregood:
    lea edx, buffer                 ; load temp buffer address in EDX
    mov [edx], al                   ; write 1st good char to temp buffer
    add edx, 1
  goodchar:
    mov al, BYTE PTR [esi]
    add esi, 1
    test eax, eax                   ; test if terminator
    jz lastword                     ; jump to last word test
    cmp BYTE PTR [chtbl+eax], 0     ; test if BYTE is NOT allowable character
    je tstword                      ; jump to word test loop
    mov [edx], al                   ; write next byte to temp buffer
    add edx, 1
    jmp goodchar
  ; ---------------------------------
  ; test word match and return
  ; ---------------------------------
  align 4
  tstword:
    mov BYTE PTR [edx], 0           ; terminate the word in temp buffer
    invoke szCmp,wrd1,ADDR buffer   ; test temp buffer against 1st word
    lea ecx, buffer
    test eax, eax                   ; if no match write original word to buffer
    jz @F
    mov ecx, wrd2                   ; if 1st word matches, put replacement address in ECX
  @@:
    mov al, [ecx]                   ; copy word to destination buffer
    add ecx, 1
    test eax, eax                   ; return on zero
    jz prebad
    mov [edi], al
    add edi, 1
    jmp @B
  ; ---------------------------------
  ; test word match and exit
  ; ---------------------------------
  align 4
  lastword:
    mov BYTE PTR [edx], 0           ; terminate the word in temp buffer
    invoke szCmp,wrd1,ADDR buffer   ; test temp buffer against 1st word
    lea ecx, buffer
    test eax, eax                   ; if no match write original word to buffer
    jz @F
    mov ecx, wrd2                   ; if 1st word matches, put replacement address in ECX
  @@:
    mov al, [ecx]                   ; copy word to destination buffer
    add ecx, 1
    test eax, eax                   ; exit on zero
    jz repout
    mov [edi], al
    add edi, 1
    jmp @B
  ; ---------------------------------
  align 4
  repout:
    mov BYTE PTR [edi], 0           ; write final terminator to destination buffer
    pop edi
    pop esi

    ret

wordreplace endp

; 

end LibMain
